module.exports = class TokenStream extends Array {
  constructor() {
    super()
    this.position = 0
  }

  advance() {
    this.position++
  }

  eat(tokenType) {
    if (this.peek() && this.peek().type === tokenType) {
      this.advance()
      return this.peek(-1)
    }
    return false
  }

  peek(step = 0) {
    return this[this.position + step]
  }
}
